﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;
using Microsoft.Win32;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using Infragistics.Documents.Excel;
using System.Diagnostics;

namespace Grid_Hieararchical_DataSet
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataSet data = new DataSet();

            DataTable table1 = new DataTable();

            DataColumn colid = new DataColumn();
            colid.ColumnName = "ID";
            colid.Caption = "ID Caption";
            colid.DataType = typeof(int);
            table1.Columns.Add(colid);
            DataColumn col1 = new DataColumn();
            col1.ColumnName = "Name";
            col1.Caption = "Name Caption";
            col1.DataType = typeof(string);
            table1.Columns.Add(col1);
            DataColumn col2 = new DataColumn();
            col2.ColumnName = "Age";
            col2.Caption = "Age Caption";
            col2.DataType = typeof(int);
            table1.Columns.Add(col2);

            table1.Rows.Add(new object[] {1, "Steve", 21 });
            table1.Rows.Add(new object[] {2, "John", 52 });
            table1.Rows.Add(new object[] {3, "Dane", 37 });


            DataTable table2 = new DataTable();

            DataColumn colid2 = new DataColumn();
            colid2.ColumnName = "ID2";
            colid2.Caption = "ID2 Caption";
            colid2.DataType = typeof(int);
            table2.Columns.Add(colid2);
            DataColumn col11 = new DataColumn();
            col11.ColumnName = "ParentName";
            col11.Caption = "Parent Name Caption";
            col11.DataType = typeof(string);
            table2.Columns.Add(col11);
            DataColumn col12 = new DataColumn();
            col12.ColumnName = "ParentAge";
            col12.Caption = "Parent Age Caption";
            col12.DataType = typeof(int);
            table2.Columns.Add(col12);

            DataColumn col13 = new DataColumn();
            col13.ColumnName = "Value";
            col13.Caption = "Value";
            col13.DataType = typeof(double);
            table2.Columns.Add(col13);

            table2.Rows.Add(new object[] {1, "Steve Sr", 21, 45.123 });
            table2.Rows.Add(new object[] { 1, "Steve Sr's wife", 21, 49.42345 });
            table2.Rows.Add(new object[] { 2, "John Sr", 21, 467.875345 });
            table2.Rows.Add(new object[] { 2, "John Sr's wife", 21, 9839.87445 });
            table2.Rows.Add(new object[] { 3, "Lab jar", 21, 344343433.142345 });



            data.Tables.Add(table1);
            data.Tables.Add(table2);
            data.Relations.Add(new DataRelation("bla",colid,colid2));

            xamDataGrid1.DataSource = data.Tables[0].AsDataView();
            xamDataGrid1.FieldLayoutSettings.AllowAddNew = true;
            xamDataGrid1.FieldLayoutSettings.AddNewRecordLocation = AddNewRecordLocation.OnTop;
            xamDataGrid1.Records.ExpandAll(true);

        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            // with a file
            string file = "";
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.CellExporting += new EventHandler<CellExportingEventArgs>(exporter_CellExporting);
            Workbook wb = new Workbook();
            for (int intc = 0; intc <= 20; intc++)
            {
                try
                {
                    file = System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData), "test" + intc.ToString() + ".xls");
                    wb = exporter.Export(this.xamDataGrid1, file, WorkbookFormat.Excel97To2003);
                    break;
                }
                catch
                {
                }
            }
            if (wb != null)
            {
                wb.Save(file);
                Process.Start(file);
            }
        }

        void exporter_CellExporting(object sender, CellExportingEventArgs e)
        {
            if (e.Field.DataType == typeof(double))
            {
                e.FormatSettings.FormatString = "#,##0.00";
            }

            if (e.Field.DataType == typeof(int))
            {
                e.FormatSettings.FormatString = "0";
            }
        }


    }
}
